﻿using System;
using UnityEngine;
using System.Collections;
using System.Linq;
using System.Collections.Generic;
using SimpleJSON;
using Random = UnityEngine.Random;
using MacGruber;
using MVR.FileManagementSecure;



namespace SPQR
{
    public class Alive : MVRScript
    {

        protected UIDynamicButton dbutton;
        protected UIDynamicButton dbutton2;
        protected UIDynamicButton dbutton3;
        string SavePath = "Saves\\PluginData\\Alive";
        string SaveExtension = "json";

        int titles = 0;
        int countInfoOperations = 0;
        int[] countInfoOperationsMinute = new int[30];

        string[] features = new string[] { "facebase", "pucker", "blink", "brows", "mouth", "lips", "cheeks", "expressions", "microeye" };

        private bool debugMode = false;
        private bool debugStopMode = false;
        bool initblinkEnabled = false;

        private Dictionary<string, bool> allMorphsD;
        private List<DAZMorph> allMorphs;

        Dictionary<string, JSONStorableBool> enableFeatures = new Dictionary<string, JSONStorableBool>();
        Dictionary<string, JSONStorableFloat> morphTypesOccuranceConfigFloat;
        Dictionary<string, JSONStorableFloat> configValues;
        JSONStorableFloat operationsLimit;

        Dictionary<string, int> morphTypesOccuranceConfig = new Dictionary<string, int>(){
            { "morphsFaceBase", 3 },
            { "morphsPucker", 2 },
            { "morphsBlink", 1 },
            { "morphsExpression", 2 },
            { "morphsSquint", 1 },
            { "morphsFlashMouth", 5 },
            { "morphsMouthLips", 3 },
            { "morphsCheeks", 4 },
            { "morphsEyeMicro", 2 },
        };

        Dictionary<string, float> morphTypesDoitDefault = new Dictionary<string, float>(){
            { "facebase", 10f },
            { "pucker", 0.33f },
            { "blink", 0.33f },
            { "expressions", 1f },
            { "brows", 1f },
            { "mouth", 0.33f },
            { "lips", 0.33f },
            { "cheeks", 1f },
            { "microeye", 0.001f },
        };

        Dictionary<string, JSONStorableFloat> morphTypesDoitJson = new Dictionary<string, JSONStorableFloat>() { };

        string[] morphsExpression = {
            "AAsex_browhiFF6",
            "AAsex_browhiFF8",
            "AAsex_browhiFF8",
            "AAsex_brraiseER2",
            "AAsex_brraiseER4",
            "AAsex_brraiseFF2",
            "AAsex_brraiseFF5",
            "AAsex_brraiseFF6",
            "AAsex_brraiseFF8",
            "AAsex_brraiseK2",
            "AAsex_brraiseM2",
            "AAsex_brraiseOH8",
            "AAsex_brraiseOH9",
            "AAsex_brraiseSH2",
            "AAsex_brraiseSH4",
            "AAsex_brraisesm1a",
            "AAsex_sqntwrry1AA1",
            "AAsex_sqntwrry1AA3",
            "AAsex_sqntwrry1AA6",
            "AAsex_sqntwrry1FF2",
            "AAsex_sqntwrry1FF5",
            "AAsex_sqntwrry1FF6",
            "AAsex_sqntwrry1FF8",
            "AAsex_sqntwrry1K2",
            "AAsex_sqntwrry1K5",
            "AAsex_sqntwrry1M2",
            "AAsex_sqntwrry1M4",
            "AAsex_sqntwrry1M5",
            "AAsex_sqntwrry1SH2",
            "AAsex_sqntwrry1SH4",
            "AAsex_sqntwrry1sm1",
            "AAsex_sqntwrry1sm5a",
            "AAsex_sqntwrry1sm56b",
            "AAsex_sqntwrry2sm1",
            "AAsex_sqntwrry2sm1e",
            "AAsex_sqntwrry2sm5a",
            "AAsex_sqntwrry2sm6b",
            "AAsex_squintbrAA6",
            "AAsex_squintbrER4",
            "AAsex_squintbrER5",
            "AAsex_squintbrFF2",
            "AAsex_squintbrFF5",
            "AAsex_squintbrFF6",
            "AAsex_squintbrFF8",
            "AAsex_squintbrK2",
            "AAsex_squintbrM2",
            "AAsex_squintbrM5",
            "AAsex_squintbrOH4",
            "AAsex_squintbrOH7",
            "AAsex_squintbrOH8",
            "AAsex_squintbrOH9",
            "AAsex_squintbrSH2",
            "AAsex_squintbrSH4",
            "AAsex_wideAA1",
            "AAsex_wideAA3",
            "AAsex_wideAA6",
            "AAsex_wideER2",
            "AAsex_wideER4",
            "AAsex_wideER5",
            "AAsex_wideFF2",
            "AAsex_wideFF5",
            "AAsex_wideFF6",
            "AAsex_wideFF8",
            "AAsex_wideK2",
            "AAsex_wideK5",
            "AAsex_wideM2",
            "AAsex_wideOH4",
            "AAsex_wideOH7",
            "AAsex_wideOH8",
            "AAsex_wideOH9",
            "AAsex_wideSH2",
            "AAsex_wideSH4",
            "AAsex_widesm1",
            "AAsex_widesm5"

        };

        string[] morphsFaceBase ={
            "AAsex_widesm5",
            "AAsex_widesm1",
            "AAsex_wideM5",
            "AAsex_wideM4",
            "AAsex_wideM2"
        };

        string[] morphsSquint ={
            "AA_basicsquint1",
            "AA_basicsquint2",
            "AA_basicsquint3",
            "AA_basicsquint4",
            "Brow Down",
            "Brow Inner Down",
            "Brow Inner Up",
            "Brow Outer Down",
            "Brow Outer Up",
            "Brow Up",
            "Brow Up Left",
            "Brow Up Right",
            "Brow Outer Up Left",
            "Brow Outer Up Right",

        };

        string[] morphsPucker ={
            "Cheeks Balloon Pucker",
            "Lips Pucker",
            "Lips Pucker Wide"
        };

        string[] morphsBlink ={
            "Eyes Closed"
        };

        string[] morphsFlashMouth ={
            "Mouth Side-Side",
            "Mouth Corner Up-Down",
            "Mouth Narrow",
            "Jaw In-Out"
        };

        string[] morphsMouthLips ={
            "Lip Bottom In Left",
            "Lip Bottom In Right",
            "Lip Bottom Out Left",
            "Lip Bottom In Right",
            "Lip Bottom Up Left",
            "Lip Bottom Up Right",
            "Lip Top Up Left",
            "Lip Top Up Right",
            "Lip Top Down Left",
            "Lip Top Down Right",
            "Lips Close"
        };

        string[] morphsCheeks ={
            "Cheek Crease Left",
            "Cheek Crease Right",
            "Cheek Flex Left",
            "Cheek Flex Right",
            "Cheek Eye Flex Left",
            "Cheek Eye Flex Right"
        };

        string[] morphsEyeMicro ={
            "Eyes Squint Left",
            "Eyes Squint Right",
            "Eyelids Top Up Left",
            "Eyelids Top Down Right",
            "Eyelids Bottom Up Left",
            "Eyelids Bottom Up Right"
        };


        Dictionary<string, int> morphsCount = new Dictionary<string, int>();
        Dictionary<string, string> morphsQueueType = new Dictionary<string, string>();
        Dictionary<string, float> morphsQueueCurrent = new Dictionary<string, float>();
        Dictionary<string, float> morphsQueueTarget = new Dictionary<string, float>();
        Dictionary<string, float> morphsQueueSpeed = new Dictionary<string, float>();
        Dictionary<string, float> morphsQueueRewindSpeed = new Dictionary<string, float>();
        Dictionary<string, float> morphsQueueHold = new Dictionary<string, float>();
        Dictionary<string, float> morphsQueueHolding = new Dictionary<string, float>();

        Dictionary<string, float> morphTypesOccuranceConfigDefault = new Dictionary<string, float>(){
            { "facebase", 1 },
            { "pucker", 1 },
            { "blink", 1 },
            { "expressions", 1 },
            { "brows", 1 },
            { "mouth", 1 },
            { "lips", 1 },
            { "cheeks", 1 },
            { "microeye", 0 },

        };

        JSONStorableString infoCount;

        int headIndex = 0;
        int startedAverage = 0;
        bool removeHeadAddTail(int tail)
        {
            int head = countInfoOperationsMinute[headIndex];
            countInfoOperationsMinute[headIndex] = tail;
            headIndex = (headIndex + 1) % countInfoOperationsMinute.Length;
            if (startedAverage > countInfoOperationsMinute.Length) return true;
            startedAverage++;
            return false;
        }
        Dictionary<string, UIDynamicButton> buttons = new Dictionary<string, UIDynamicButton>();

        public override void Init()
        {
            initblinkEnabled = SPQRUtils.getAtomStorableBool(containingAtom.uid,"EyelidControl","blinkEnabled").val;
            SPQRUtils.setAtomStorableBool(containingAtom.uid,"EyelidControl","blinkEnabled",false);

            try
            {
              //  SuperController.LogMessage("Init called");
                Utils.OnInitUI(CreateUIElement);
                if (debugMode)
                {
                    dbutton = CreateButton("debugDoQueue");
                    if (dbutton != null)
                    {
                        dbutton.button.onClick.AddListener(doQueue);
                    }
                    dbutton2 = CreateButton("addToQueue");
                    if (dbutton2 != null)
                    {
                        dbutton2.button.onClick.AddListener(addToQueue);
                    }
                    dbutton3 = CreateButton("debugStop");
                    if (dbutton3 != null)
                    {
                        dbutton3.button.onClick.AddListener(debugStop);
                    }
                }

                CreateTitle("SPQR Alive", 50, false);
                CreateTitle("v5.0", 30, true);


                infoCount = new JSONStorableString("countinfo", "");
                UIDynamicTextField dtext = CreateTextField(infoCount, true);
                dtext.UItext.supportRichText = true;
                dtext.backgroundColor = new Color(0.42f, 0.03f, 0.51f, 0.7f);
                dtext.textColor = new Color(1f, 1f, 1f, 0.9f);
                dtext.height = 200f;

                buttons.Add("load_preset", CreateButton("Load Preset",true));
                buttons["load_preset"].button.onClick.AddListener(() =>
                {
                    FileManagerSecure.CreateDirectory(SavePath);
                    var shortcuts = FileManagerSecure.GetShortCutsForDirectory(SavePath);
                    SuperController.singleton.GetMediaPathDialog(HandleLoadPreset, SaveExtension, SavePath, false, true, false, null, false, shortcuts);
                });

                buttons.Add("save_preset", CreateButton("Save Preset", true));
                buttons["save_preset"].button.onClick.AddListener(() =>
                {
                    FileManagerSecure.CreateDirectory(SavePath);
                    var fileBrowserUI = SuperController.singleton.fileBrowserUI;
                    fileBrowserUI.SetTitle("Save ticklish preset");
                    fileBrowserUI.fileRemovePrefix = null;
                    fileBrowserUI.hideExtension = true;
                    fileBrowserUI.keepOpen = false;
                    fileBrowserUI.canCancel = true;
                    fileBrowserUI.fileFormat = SaveExtension;
                    fileBrowserUI.defaultPath = SavePath;
                    fileBrowserUI.showDirs = true;
                    fileBrowserUI.showFiles = true;
                    fileBrowserUI.shortCuts = null;
                    fileBrowserUI.browseVarFilesAsDirectories = false;
                    fileBrowserUI.SetTextEntry(true);
                    fileBrowserUI.Show(HandleSavePreset);
                    fileBrowserUI.fileEntryField.text = (int)(DateTime.UtcNow - new DateTime(1970, 1, 1)).TotalSeconds + "." + SaveExtension;
                    fileBrowserUI.ActivateFileNameField();
                });


                Utils.SetupButton(this, "Clear Expressions", ResetAllM, true);
                Utils.SetupAction(this, "Clear Expressions", ResetAllM);

                Utils.SetupButton(this, "Disable All", DisableAll, true);
                Utils.SetupAction(this, "Disable All", DisableAll);

                Utils.SetupButton(this, "Enable All", EnableAll, true);
                Utils.SetupAction(this, "Enable All", EnableAll);

                configValues = new Dictionary<string, JSONStorableFloat>();

                operationsLimit = new JSONStorableFloat("Operations Limit", 1000f, 0f, 10000f, true);
                operationsLimit.storeType = JSONStorableParam.StoreType.Full;
                RegisterFloat(operationsLimit);
                CreateSlider(operationsLimit, true);

                configValues.Add("hold", new JSONStorableFloat("Hold factor", 1f, 0f, 20f, true));
                configValues["hold"].storeType = JSONStorableParam.StoreType.Full;
                RegisterFloat(configValues["hold"]);
                CreateSlider(configValues["hold"], true);

                configValues.Add("power", new JSONStorableFloat("Power factor", 1f, 0f, 3f, true));
                configValues["power"].storeType = JSONStorableParam.StoreType.Full;
                RegisterFloat(configValues["power"]);
                CreateSlider(configValues["power"], true);


                configValues.Add("speed", new JSONStorableFloat("Speed factor", 1f, 0f, 100f, true));
                configValues["speed"].storeType = JSONStorableParam.StoreType.Full;
                RegisterFloat(configValues["speed"]);
                CreateSlider(configValues["speed"], true);

                configValues.Add("rewindspeed", new JSONStorableFloat("Rewind Speed factor", 1f, 0f, 100f, true));
                configValues["rewindspeed"].storeType = JSONStorableParam.StoreType.Full;
                RegisterFloat(configValues["rewindspeed"]);
                CreateSlider(configValues["rewindspeed"], true);




                morphTypesOccuranceConfigFloat = new Dictionary<string, JSONStorableFloat>();
                Dictionary<string, UIDynamicSlider> slidersDictionary = new Dictionary<string, UIDynamicSlider>();



                foreach (var feature in features)
                {
                    enableFeatures[feature] = new JSONStorableBool("Enable " + feature, true);
                    enableFeatures[feature].storeType = JSONStorableParam.StoreType.Full;
                    RegisterBool(enableFeatures[feature]);
                    CreateToggle(enableFeatures[feature], false);

                    morphTypesOccuranceConfigFloat.Add(feature, new JSONStorableFloat("Iterations " + feature, morphTypesOccuranceConfigDefault[feature], 0f, 10f, true));
                    morphTypesOccuranceConfigFloat[feature].storeType = JSONStorableParam.StoreType.Full;
                    RegisterFloat(morphTypesOccuranceConfigFloat[feature]);
                    slidersDictionary[feature] = CreateSlider(morphTypesOccuranceConfigFloat[feature], false);
                    slidersDictionary[feature].slider.wholeNumbers = true;

                    morphTypesDoitJson.Add(feature, new JSONStorableFloat("Chance " + feature, morphTypesDoitDefault[feature], 0f, 100f, true));
                    morphTypesDoitJson[feature].storeType = JSONStorableParam.StoreType.Full;
                    RegisterFloat(morphTypesDoitJson[feature]);
                    CreateSlider(morphTypesDoitJson[feature], false);


                    Utils.SetupSpacer(this, 50f, false);
                }

                GenerateDAZMorphsControlUI morphControl = returnMorphs();
                allMorphs = morphControl.GetMorphs();

                allMorphsD = new Dictionary<string, bool>();
                allMorphs.ForEach((morph) =>
                {
                    try
                    {
                        allMorphsD[morph.displayName] = true;
                    }
                    catch (Exception e) { }
                });
                UIUpdate();
                clearAll();
            }
            catch (Exception e)
            {
                SuperController.LogError("Exception caught: " + e);
            }
        }

        private void UIUpdate()
        {
        }


        // Start is called once before Update or FixedUpdate is called and after Init()
        void Start()
        {
            try
            {
                InvokeRepeating("UpdateSecond", 1f, 1f);
            }
            catch (Exception e)
            {
                SuperController.LogError("Exception caught: " + e);
            }
        }

        void UpdateSecond()
        {
            infoCount.val = "Operations per second:\r\n<b>" + countInfoOperations + "</b>\r\n";
            if (removeHeadAddTail(countInfoOperations))
            {
                infoCount.val += "Average:\r\n<b>" + Math.Round(countInfoOperationsMinute.Average(), 2) + "</b>\r\n ";
            }
            infoCount.val += "Queued:\r\n<b>" + morphsQueueCurrent.Count + "</b>";

            countInfoOperations = 0;
        }

        // Update is called with each rendered frame by Unity
        void Update()
        {
            try
            {
                if (!debugStopMode)
                {
                    doQueue();
                }
            }
            catch (Exception e)
            {
                SuperController.LogError("Exception caught: " + e);
            }
        }

        // FixedUpdate is called with each physics simulation frame by Unity
        void FixedUpdate()
        {
            try
            {

            }
            catch (Exception e)
            {
                SuperController.LogError("Exception caught: " + e);
            }
        }

        // OnDestroy is where you should put any cleanup
        // if you registered objects to supercontroller or atom, you should unregister them here
        void OnDestroy()
        {
            debugStop();
            clearAll();
            allMorphs = null;
            SPQRUtils.setAtomStorableBool(containingAtom.uid,"EyelidControl","blinkEnabled",initblinkEnabled);
        }

        void OnDisable()
        {
            clearAll();
            SPQRUtils.setAtomStorableBool(containingAtom.uid,"EyelidControl","blinkEnabled",initblinkEnabled);
        }


        /** new functions */
        void addToQueue()
        {
            if (enableFeatures["facebase"].val) checkAddMorphFaceBase();
            if (enableFeatures["pucker"].val) checkAddMorphPucker();
            if (enableFeatures["blink"].val) checkAddMorphBlink();
            if (enableFeatures["brows"].val) checkAddMorphSquint();
            if (enableFeatures["mouth"].val) checkAddMorphFlashMouth();
            if (enableFeatures["lips"].val) checkAddMorphsMouthLips();
            if (enableFeatures["cheeks"].val) checkAddMorphCheeks();
            if (enableFeatures["expressions"].val) checkAddMorphExpression();
            if (enableFeatures["microeye"].val) checkAddMorphEyeMicro();
        }


        void clearAll()
        {
            string[] combined = morphsExpression.Concat(morphsBlink).ToArray();
            combined = combined.Concat(morphsCheeks).ToArray();
            combined = combined.Concat(morphsEyeMicro).ToArray();
            combined = combined.Concat(morphsFaceBase).ToArray();
            combined = combined.Concat(morphsFlashMouth).ToArray();
            combined = combined.Concat(morphsMouthLips).ToArray();
            combined = combined.Concat(morphsPucker).ToArray();
            combined = combined.Concat(morphsSquint).ToArray();

            allMorphs.ForEach((morph) =>
            {
                try
                {
                    var name = morph.displayName;
                    if (combined.Contains(name))
                    {
                        morph.morphValue = 0f;
                    }
                }
                catch (Exception e) { }
            });



        }


        public override JSONClass GetJSON(bool includePhysical = true, bool includeAppearance = true, bool forceStore = false)
		{
			JSONClass jc = base.GetJSON(includePhysical, includeAppearance, forceStore);
			if (includePhysical || forceStore)
			{
				needsStore = true;
			
			}
			return jc;
		}

		public override void LateRestoreFromJSON(JSONClass jc, bool restorePhysical = true, bool restoreAppearance = true, bool setMissingToDefault = true)
		{
			base.LateRestoreFromJSON(jc, restorePhysical, restoreAppearance, setMissingToDefault);
			
		}


        /*
		public override JSONClass GetJSON(bool includePhysical = true, bool includeAppearance = true, bool forceStore = false)
		{
			JSONClass jc = base.GetJSON(includePhysical, includeAppearance, forceStore);
			if (includePhysical || forceStore)
			{
				needsStore = true;
			
			}
			return jc;
		}

		public override void LateRestoreFromJSON(JSONClass jc, bool restorePhysical = true, bool restoreAppearance = true, bool setMissingToDefault = true)
		{
			base.LateRestoreFromJSON(jc, restorePhysical, restoreAppearance, setMissingToDefault);

		}
*/

        void DisableAll()
        {
            foreach (var feature in features)
            {
                enableFeatures[feature].val = false;
            }
        }
        void EnableAll()
        {
            foreach (var feature in features)
            {
                enableFeatures[feature].val = true;
            }
        }

        void doQueue()
        {

            /*
			//DumpToConsole(morphsQueueCurrent);
			debug("morphsCount morphsFaceBase:" + getMorphsCount("morphsFaceBase") );
			debug("morphsCount morphsEyeMicro:" + getMorphsCount("morphsEyeMicro") );
			
			if(morphsQueueCurrent.Count > 200){
				morphsQueueClear();
			}
			*/
            addToQueue();

            if (morphsQueueCurrent.Count < 1)
            {
                return;
            }

            allMorphs.ForEach((morph) =>
            {
                try
                {
                    var name = morph.displayName;

                    if (morphsQueueCurrent.ContainsKey(name))
                    {
                        float morphValue = morphsQueueCurrent[name];
                        string morphType = morphsQueueType[name];
                        float morphTarget = morphsQueueTarget[name];
                        float morphHold = morphsQueueHold[name];
                        float morphHolding = morphsQueueHolding[name];
                        float morphSpeed = morphsQueueSpeed[name];
                        float morphRewindSpeed = morphsQueueRewindSpeed[name];
                        float morphSpeedCounter = morphsQueueSpeedCounter(morphSpeed);

                        bool finished = false;
                        if (morphTarget < morphValue)
                        {
                            morphValue -= morphSpeed;
                            if (morphValue < morphTarget)
                            {
                                morphValue = morphTarget;
                                finished = true;
                            }
                        }
                        else
                        {
                            morphValue += morphSpeed;
                            if (morphValue > morphTarget)
                            {
                                morphValue = morphTarget;
                                finished = true;
                            }
                        }


                        morphSetCurrent(name, morphValue);

                        if (countInfoOperations >= operationsLimit.val)
                        {
                            debug(" skipped limit reached");
                            return;
                        }
                        countInfoOperations++;


                        morph.morphValue = morphValue;



                        if (finished)
                        {
                            if (morphValue == 0f)
                            {
                                debug(name + " val finished: unset");
                                morphUnset(name, morphType);
                            }
                            else
                            {

                                if (morphHolding > 0f && morphHold > 0f)
                                {
                                    morphHolding -= morphHold;
                                    morphsQueueHolding[name] = morphHolding;
                                    debug(name + " val finished: holding");
                                }
                                else
                                {
                                    debug(name + " val finished: set rewind");
                                    morphSetTarget(name, morphType, 0f, morphRewindSpeed, morphGetHold("random"), morphRewindSpeed);
                                }
                            }
                        }


                    }
                }
                catch (Exception e) { }
            });



        }
        int getMorphsCount(string name)
        {
            if (!morphsCount.ContainsKey(name))
            {
                return 0;
            }
            return morphsCount[name];
        }
        void morphUnset(string name, string type)
        {
            morphsCountDecrement(type);
            morphsQueueType.Remove(name);
            morphsQueueCurrent.Remove(name);
            morphsQueueTarget.Remove(name);
            morphsQueueSpeed.Remove(name);
            morphsQueueRewindSpeed.Remove(name);
            morphsQueueHold.Remove(name);
            morphsQueueHolding.Remove(name);

        }

        void debug(string message)
        {
            if (debugMode == false) return;
            SuperController.LogMessage(message);
        }

        string morphsGetRandom(string[] morphs)
        {
            int rand = Random.Range(0, (morphs.Length - 1));
            return morphs[rand];
        }
        float morphGetHold(string power)
        {
            float hold;
            int min = 1;
            int max = 1000;
            switch (power)
            {
                case "longer":
                    max = 10;
                    min = 1;
                    break;
                case "long":
                    max = 100;
                    break;
                case "medium":
                    min = 200;
                    max = 400;
                    break;
                case "short":
                    min = 400;
                    max = 700;
                    break;
                case "shorter":
                    min = 700;
                    max = 10000;
                    break;
            }
            hold = Random.Range(min, max);
            hold = hold / 1000;
            return hold;
        }
        float morphGetSpeed(string power)
        {
            float val = morphGetValue(power, true);
            val /= 100;
            val += 0.001f;
            return val;
        }
        float morphsQueueSpeedCounter(float morphSpeed)
        {
            float val = 0f;
            if (Random.Range(0, 2) == 1)
            {
                val = morphSpeed;
            }

            return val;
        }

        float morphGetValue(string power, bool positiveOnly = false)
        {
            int start = -100;
            int end = 100;

            if (power == "random")
            {
                power = Random.Range(1, 7).ToString();
            }

            switch (power)
            {
                case "lightest":
                case "1":
                    start = -3;
                    end = 5;
                    break;
                case "lighter":
                case "2":
                    start = -5;
                    end = 10;
                    break;
                case "light":
                case "3":
                    start = -10;
                    end = 15;
                    break;
                case "medium":
                case "4":
                    start = -15;
                    end = 20;
                    break;
                case "heavy":
                case "5":
                    start = -20;
                    end = 30;
                    break;
                case "heavier":
                case "6":
                    start = -30;
                    end = 45;
                    break;
                case "heaviest":
                case "7":
                    start = -50;
                    end = 65;
                    break;
                case "total":
                    start = 100;
                    end = 100;
                    break;
            }

            if (positiveOnly) start = 0;

            float rand = Random.Range(start, end) / 100f;
            return rand;

        }

        void resetMorphs()
        {
        }

        void debugStop()
        {

            debugStopMode = !debugStopMode;
            resetMorphs();
            morphsQueueClear();

        }

        void morphsQueueClear()
        {
            morphsCount = new Dictionary<string, int>();
            morphsQueueType = new Dictionary<string, string>();
            morphsQueueCurrent = new Dictionary<string, float>();
            morphsQueueTarget = new Dictionary<string, float>();
            morphsQueueSpeed = new Dictionary<string, float>();
            morphsQueueRewindSpeed = new Dictionary<string, float>();
            morphsQueueHold = new Dictionary<string, float>();
            morphsQueueHolding = new Dictionary<string, float>();
        }

        void addMorphFaceBase()
        {
            string morphName = morphsGetRandom(morphsFaceBase);
            string morphType = "morphsFaceBase";
            float morphTarget = morphGetValue("medium");
            float morphSpeed = morphGetSpeed("lightest");
            float morphRewindSpeed = morphGetSpeed("random");
            float morphHold = morphGetHold("random");
            morphSetTarget(morphName, morphType, morphTarget, morphSpeed, morphHold, morphRewindSpeed);
        }
        void addMorphPucker()
        {
            string morphName = morphsGetRandom(morphsPucker);
            string morphType = "morphsPucker";
            float morphTarget = morphGetValue("heavy", true);
            float morphSpeed = morphGetSpeed("heavy");
            float morphRewindSpeed = morphGetSpeed("lightest");
            float morphHold = morphGetHold("longer") / 10;
            morphSetTarget(morphName, morphType, morphTarget, morphSpeed, morphHold, morphRewindSpeed);
        }

        void checkAddMorphFaceBase()
        {
            if (getMorphsCount("morphsFaceBase") >= morphTypesOccuranceConfigFloat["facebase"].val) return;
            bool doit = false;

            if (Random.Range(0, 100) < morphTypesDoitJson["facebase"].val)
            {
                doit = true;
            }

            if (doit)
            {
                addMorphFaceBase();
            }
        }

        void checkAddMorphPucker()
        {
            if (getMorphsCount("morphsPucker") >= morphTypesOccuranceConfigFloat["pucker"].val) return;
            bool doit = false;
            if (Random.Range(0, 100) < morphTypesDoitJson["pucker"].val)
            {
                doit = true;
            }
            if (doit)
            {
                addMorphPucker();
            }
        }
        void checkAddMorphBlink()
        {
            if (getMorphsCount("morphsBlink") >= morphTypesOccuranceConfigFloat["blink"].val) return;
            bool doit = false;
            if (Random.Range(0, 100) < morphTypesDoitJson["blink"].val)
            {
                doit = true;
            }
            if (doit)
            {
                addMorphBlink();
            }
        }

        void addMorphBlink()
        {
            string morphName = morphsGetRandom(morphsBlink);
            string morphType = "morphsBlink";
            float morphTarget = morphGetValue("total");
            float morphSpeed = morphGetSpeed("heaviest") * 30;
            float morphRewindSpeed = morphGetSpeed("heaviest") * 50;
            float morphHold = 0f;
            morphSetTarget(morphName, morphType, morphTarget, morphSpeed, morphHold, morphRewindSpeed);
        }

        void checkAddMorphSquint()
        {
            if (getMorphsCount("morphsSquint") >= morphTypesOccuranceConfigFloat["brows"].val) return;
            bool doit = false;
            if (Random.Range(0, 100) < morphTypesDoitJson["brows"].val)
            {
                doit = true;
            }

            if (doit)
            {
                addMorphSquint();
            }
        }

        void addMorphSquint()
        {
            string morphName = morphsGetRandom(morphsSquint);
            string morphType = "morphsSquint";
            float morphTarget = morphGetValue("heavy");
            float morphSpeed = morphGetSpeed("random");
            float morphRewindSpeed = morphGetSpeed("short");
            float morphHold = morphGetHold("longer") * 10;
            morphSetTarget(morphName, morphType, morphTarget, morphSpeed, morphHold, morphRewindSpeed);
        }


        void checkAddMorphFlashMouth()
        {
            if (getMorphsCount("morphsFlashMouth") >= morphTypesOccuranceConfigFloat["mouth"].val) return;
            bool doit = false;
            if (Random.Range(0, 100) < morphTypesDoitJson["mouth"].val)
            {
                doit = true;
            }

            if (doit)
            {
                addMorphFlashMouth();
                addMorphFlashMouth();
                if (Random.Range(0, 2) == 1)
                {
                    addMorphFlashMouth();
                    addMorphFlashMouth();
                }
                if (Random.Range(1, 6) == 1)
                {
                    addMorphFlashMouth();
                    addMorphFlashMouth();
                }
                if (Random.Range(1, 12) == 1)
                {
                    addMorphFlashMouth();
                    addMorphFlashMouth();
                }
                if (Random.Range(1, 50) == 1)
                {
                    addMorphFlashMouth();
                    addMorphFlashMouth();
                }
            }
        }

        void addMorphFlashMouth()
        {
            string morphName = morphsGetRandom(morphsFlashMouth);
            string morphType = "morphsFlashMouth";
            float morphTarget = morphGetValue("medium");
            float morphSpeed = morphGetSpeed("random");
            float morphRewindSpeed = morphGetSpeed("light");
            float morphHold = morphGetHold("shorter") * 100;
            morphSetTarget(morphName, morphType, morphTarget, morphSpeed, morphHold, morphRewindSpeed);
        }


        void checkAddMorphsMouthLips()
        {
            if (getMorphsCount("morphsMouthLips") >= morphTypesOccuranceConfigFloat["lips"].val) return;
            bool doit = false;
            if (Random.Range(0, 100) < morphTypesDoitJson["lips"].val)
            {
                doit = true;
            }

            if (doit)
            {
                addMorphsMouthLips();
                if (Random.Range(0, 2) == 1)
                {
                    addMorphsMouthLips();
                }
                if (Random.Range(0, 2) == 1)
                {
                    addMorphsMouthLips();
                    addMorphsMouthLips();
                }
                if (Random.Range(1, 6) == 1)
                {
                    addMorphsMouthLips();
                    addMorphsMouthLips();
                    addMorphsMouthLips();
                }
                if (Random.Range(1, 12) == 1)
                {
                    addMorphsMouthLips();
                    addMorphsMouthLips();
                    addMorphsMouthLips();
                }
            }
        }

        void addMorphsExpression()
        {
            string morphName = morphsGetRandom(morphsExpression);
            string morphType = "morphsExpressions";
            float morphTarget = morphGetValue("heavy", true);
            float morphSpeed = morphGetSpeed("random");
            float morphRewindSpeed = morphGetSpeed("random");
            float morphHold = morphGetHold("longer") * 10;
            morphSetTarget(morphName, morphType, morphTarget, morphSpeed, morphHold, morphRewindSpeed);
        }

        void addMorphsMouthLips()
        {
            string morphName = morphsGetRandom(morphsMouthLips);
            string morphType = "morphsMouthLips";
            float morphTarget = morphGetValue("random");
            float morphSpeed = morphGetSpeed("random");
            float morphRewindSpeed = morphGetSpeed("random");
            float morphHold = morphGetHold("longer") * 10;
            morphSetTarget(morphName, morphType, morphTarget, morphSpeed, morphHold, morphRewindSpeed);
        }

        void checkAddMorphEyeMicro()
        {
            if (getMorphsCount("morphsEyeMicro") >= morphTypesOccuranceConfigFloat["microeye"].val) return;
            bool doit = false;
            if (Random.Range(0, 100) < morphTypesDoitJson["microeye"].val)
            {
                doit = true;
            }

            if (doit)
            {
                addMorphsEyeMicro();
                if (Random.Range(0, 2) == 1)
                {
                    addMorphsEyeMicro();
                }
                if (Random.Range(0, 4) == 1)
                {
                    addMorphsEyeMicro();
                }
                if (Random.Range(1, 10) == 1)
                {
                    addMorphsEyeMicro();
                }
            }
        }

        void addMorphsEyeMicro()
        {
            string morphName = morphsGetRandom(morphsEyeMicro);
            string morphType = "morphsEyeMicro";
            float morphTarget = morphGetValue("lightest") / 100;
            float morphSpeed = morphGetSpeed("heaviest") * 10;
            float morphRewindSpeed = morphGetSpeed("heaviest") * 10;
            float morphHold = morphGetHold("shortest");
            morphSetTarget(morphName, morphType, morphTarget, morphSpeed, morphHold, morphRewindSpeed);
        }

        void checkAddMorphExpression()
        {
            if (getMorphsCount("morphsExpressions") >= morphTypesOccuranceConfigFloat["expressions"].val) return;
            bool doit = false;
            if (Random.Range(0, 100) < morphTypesDoitJson["expressions"].val)
            {
                doit = true;
            }

            if (doit)
            {
                addMorphsExpression();
            }

        }

        void checkAddMorphCheeks()
        {
            if (getMorphsCount("morphsCheeks") >= morphTypesOccuranceConfigFloat["cheeks"].val) return;
            bool doit = false;
            if (Random.Range(0, 100) < morphTypesDoitJson["cheeks"].val)
            {
                doit = true;
            }

            if (doit)
            {
                addMorphsCheeks();
                if (Random.Range(0, 2) == 1)
                {
                    addMorphsMouthLips();
                }
                if (Random.Range(0, 2) == 1)
                {
                    addMorphsCheeks();
                }
                if (Random.Range(1, 6) == 1)
                {
                    addMorphsMouthLips();
                }
                if (Random.Range(1, 12) == 1)
                {
                    addMorphsMouthLips();
                    addMorphsMouthLips();
                    addMorphsMouthLips();
                }
            }
        }

        void addMorphsCheeks()
        {
            string morphName = morphsGetRandom(morphsCheeks);
            string morphType = "morphsCheeks";
            float morphTarget = morphGetValue("random");
            float morphSpeed = morphGetSpeed("random") * 10;
            float morphRewindSpeed = morphGetSpeed("lightest");
            float morphHold = morphGetHold("shorter");
            morphSetTarget(morphName, morphType, morphTarget, morphSpeed, morphHold, morphRewindSpeed);
        }

        bool morphExists(string morphName)
        {
            return allMorphsD.ContainsKey(morphName);
        }
        void morphSetTarget(string morphName, string morphType, float morphTarget, float morphSpeed, float morphHold, float morphRewindSpeed)
        {

            morphTarget *= configValues["power"].val;
            morphHold *= configValues["hold"].val;

            //morphSpeed*=configValues["speed"].val;
            //morphRewindSpeed*=configValues["rewindspeed"].val;

            if (!morphExists(morphName))
            {
                debug("morph not found: " + morphName);
                return;
            }
            if (!morphsQueueCurrent.ContainsKey(morphName))
            {
                morphsQueueCurrent[morphName] = 0f;
                morphsCountIncrement(morphType);
            }
            morphsQueueType[morphName] = morphType;
            morphsQueueTarget[morphName] = morphTarget;
            morphsQueueSpeed[morphName] = morphSpeed;
            morphsQueueRewindSpeed[morphName] = morphRewindSpeed;
            morphsQueueHold[morphName] = morphHold;
            morphsQueueHolding[morphName] = 1f;
            debug(morphName + " target: " + morphTarget + " with speed: " + morphSpeed);
        }

        void morphSetCurrent(string morphName, float morphCurrent)
        {
            morphsQueueCurrent[morphName] = morphCurrent;
            //debug(morphName + " current: "+morphCurrent);
        }

        void morphsCountIncrement(string morphName)
        {
            if (!morphsCount.ContainsKey(morphName))
            {
                morphsCount[morphName] = 0;
            }
            morphsCount[morphName]++;
        }
        void morphsCountDecrement(string morphName)
        {
            if (!morphsCount.ContainsKey(morphName))
            {
                morphsCount[morphName] = 0;
            }
            morphsCount[morphName]--;

        }

        void ResetAllM()
        {
            debugStop();
            clearAll();
            debugStopMode = false;
        }

        GenerateDAZMorphsControlUI returnMorphs()
        {
            JSONStorable geometry = containingAtom.GetStorableByID("geometry");
            DAZCharacterSelector character = geometry as DAZCharacterSelector;
            return character.morphsControlUI;
        }

        void DumpToConsole(object obj)
        {
            var output = JsonUtility.ToJson(obj, true);
            debug(output);
        }

        private void CreateTitle(string text, int fontsize, bool right, int spacing)
        {
            CreateTitle(text, fontsize, right);
            Utils.SetupSpacer(this, spacing, right);
        }
        private void CreateTitle(string text, int fontsize, bool right)
        {
            JSONStorableString title1 = new JSONStorableString("title" + (++titles), "\n<size=" + fontsize + "><b>" + text + "</b></size>");
            UIDynamicTextField title1text = CreateTextField(title1, right);
            title1text.UItext.supportRichText = true;
            title1text.backgroundColor = new Color(0f, 0f, 0f, 0f);
            title1text.textColor = new Color(0.42f, 0.03f, 0.51f, 1f);
            title1text.height = 100f;
            title1text.UItext.alignment = right ? TextAnchor.MiddleRight : TextAnchor.MiddleLeft;
        }

        private void HandleLoadPreset(string path)
        {
           if (path == null) return;
            var jc = (JSONClass)LoadJSON(path);
            base.RestoreFromJSON(jc);
        }

        private void HandleSavePreset(string path)
        {
            SuperController.singleton.fileBrowserUI.fileFormat = null;
            if (path == null) return;
            var jc = GetJSON(true,true,true);
            SaveJSON(jc, path);
        }


    }
}